#include <stdio.h>
#include <windows.h>
#include <tlhelp32.h>

#define GET_FZ 4
HANDLE (WINAPI *xOpenThread)(DWORD a,BOOL b,DWORD c);

print_thr(HANDLE h, THREADENTRY32 thr)
{
	int a;
	DWORD x;
	DWORD st_adr;
	HANDLE ht, hp;
	CONTEXT context;
	DWORD buf[GET_FZ];               
	MEMORY_BASIC_INFORMATION mbi;
                                          
	context.ContextFlags = CONTEXT_CONTROL;
	ht = xOpenThread(THREAD_GET_CONTEXT, 0, thr.th32ThreadID);

	printf("cntUsage           : %Xh\n",thr.cntUsage);
	printf("th32ThreadID       : %Xh\n",thr.th32ThreadID);
	printf("th32OwnerProcessID : %Xh\n",thr.th32OwnerProcessID);
	printf("tpBasePri          : %Xh\n",thr.tpBasePri);
	printf("tpDeltaPri         : %Xh\n",thr.tpDeltaPri);
	printf("dwFlags            : %Xh\n",thr.dwFlags);
	printf("handle             : %Xh\n",(ht)?(DWORD)ht:0xBAD);

	if (ht)
	{
		GetThreadContext(ht,&context);
		printf("ESP                : %08Xh\n",context.Esp?context.Esp:0xDEADBEEF);

		if (hp = OpenProcess(PROCESS_VM_READ | PROCESS_QUERY_INFORMATION,0,thr.th32OwnerProcessID))
		{	
			if (VirtualQueryEx(hp, (void*)context.Esp, &mbi, sizeof(mbi))==sizeof(mbi))
			{
				x = (DWORD) mbi.BaseAddress + mbi.RegionSize;
			
				if (ReadProcessMemory(hp,(char*)x-GET_FZ*sizeof(DWORD),buf,GET_FZ*sizeof(DWORD),&a))
				{
					st_adr=((buf[GET_FZ-3])?buf[GET_FZ-3]:buf[GET_FZ-2]);
					printf("start address      : %08Xh\n",st_adr?st_adr:0xDEADBEEF);

					if (st_adr)
					{
						printf("point to args      : %08Xh\n",((buf[GET_FZ-3])?buf[GET_FZ-2]:buf[GET_FZ-1]));
						if (VirtualQueryEx(hp, (void*)st_adr, &mbi, sizeof(mbi))==sizeof(mbi))
						printf("type               : %s\n",(mbi.Type==MEM_IMAGE)?"MEM_IMAGE":(mbi.Type==MEM_MAPPED)?"MEM_MAPPED":(mbi.Type==MEM_PRIVATE)?"MEM_PRIVATE":"UNKNOWN");
					}
					printf("[%08Xh:",x - GET_FZ*sizeof(DWORD));
					for (a = 0;a < GET_FZ; a++) printf(" %08X",buf[a]);printf("]\n");		
        		}
			}
			CloseHandle(hp);
		}
		else
		{
		    printf("VirtualQueryEx     : error\n");
		}

		CloseHandle(ht);
	}
	return 1;	
}


printf_pe(PROCESSENTRY32 pe)
{
	printf("szExeFile           : %s\n",  pe.szExeFile);
	printf("cntUsage            : %Xh\n", pe.cntUsage);
	printf("th32ProcessID       : %Xh\n", pe.th32ProcessID);
	printf("th32DefaultHeapID   : %Xh\n", pe.th32DefaultHeapID);
	printf("th32ModuleID        : %Xh\n", pe.th32ModuleID);
	printf("cntThreads          : %Xh\n", pe.cntThreads);
	printf("th32ParentProcessID : %Xh\n", pe.th32ParentProcessID);
	printf("pcPriClassBase      : %Xh\n", pe.pcPriClassBase);
	printf("dwFlags             : %Xh\n", pe.dwFlags);
	return 1;
}

int main()
{
	int a;
	HANDLE h;
	HINSTANCE hst;
	PROCESSENTRY32 pe;
	THREADENTRY32 thr;

	if (hst = LoadLibrary("KERNEL32.DLL"))
		xOpenThread=(HANDLE(WINAPI*)(DWORD,BOOL,DWORD))GetProcAddress(hst,"OpenThread");
	else 
		return printf("-ERR:LoadLibrary(\"KERNEL32.DLL\")\x7\n");

	if (!xOpenThread) return printf("-ERR:Rq W2K or higher!\x7\n");

	printf("LoadLibraryA at : %08Xh\nLoadLibraryW at : %08Xh\n\n",
			GetProcAddress(hst,"LoadLibraryA"),GetProcAddress(hst,"LoadLibraryW"));


	if (!(h = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0)))
		return printf("-ERR:CreateToolhelp32Snapshot!\x7\n");

	printf("* * * PROCESS INFO * * *\n");
	pe.dwSize = sizeof(PROCESSENTRY32); a = Process32First(h, &pe);

	if (a && printf_pe(pe)) while(Process32Next(h,&pe))
		printf("\n-----------------------------------------------------\n"),printf_pe(pe);
	
	CloseHandle(h);	

	if (!(h = CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD,0)))
		return printf("-ERR:CreateToolhelp32Snapshot!\x7\n");

	printf("\n* * * THREAD INFO * * *\n");
	thr.dwSize = sizeof(THREADENTRY32); a = Thread32First(h, &thr);

	if (a && print_thr(h, thr)) 	while(Thread32Next(h, &thr))
		printf("\n--thr------------------------------------------------\n"),print_thr(h, thr);

	CloseHandle(h);
			
	return 0;
}
